#include<bits/stdc++.h>

using namespace std;
long long T,N;
long long A[30007],B[30007],a,b,al,bl;
int main(){
    cin>>T;

    for(int i=1;i<=T;i++){
        cin>>N;
        for(int i=1;i<=N;i++){
        cin>>A[i];
        if(A[i]!=0){
        a=A[i];
        al=i;
            }
        }
        for(int j=1;j<=N;j++){
            cin>>B[j];
        if(B[j]!=0){
        b=B[j];
        bl=j;
        }
    }
        if((b==a and abs(bl-al)%2==1) or (b!=a and abs(bl-al)%2==0)){
            cout<<"NE"<<endl;
        }
        else{
            cout<<"DA"<<endl;
        }
    }
return 0;
}